Set Implicit Arguments.
Require Export LibInt CFSpec CFPrint.
Generalizable Variables a A. 

(* TODO: replace "ml" prefix with a "Pervasives_ml" module *)

(************************************************************)
(** Locations *)

Parameter ml_phy_eq : func.
Parameter ml_phy_neq : func.


(************************************************************)
(** References *)

Parameter ml_ref : func.
Parameter ml_get : func.
Parameter ml_set : func.
Parameter ml_free : func.

(** Strong references *)

Parameter ml_sset : func.

(** Integer references *)

Parameter ml_incr : func.
Parameter ml_decr : func.


(************************************************************)
(** Boolean *)

Parameter ml_eqb : func.
Parameter ml_and : func.
Parameter ml_or : func.


(************************************************************)
(** Arithmetic *)

Parameter ml_plus : func.
Parameter ml_minus : func.
Parameter ml_div : func.
Parameter ml_mod : func.  

Parameter ml_leq : func.
Parameter ml_geq : func.
Parameter ml_lt : func.
Parameter ml_gt : func.


(************************************************************)
(** Pairs *)

Parameter ml_fst : func.
Parameter ml_snd : func.


(************************************************************)
(** Arrays *)

Parameter ml_array_make : func.
Parameter ml_array_get : func.
Parameter ml_array_set : func.
Parameter ml_array_length : func.
Parameter ml_array_init : func. (* todo spec *)


(************************************************************)
(** Lists *)

Parameter ml_list_iter : func.
Parameter ml_list_fold_left : func.  (* todo spec *)
Parameter ml_list_fold_right : func.  (* todo spec *)
Parameter ml_list_nth : func.  (* todo spec *)


(************************************************************)
(** Stacks *)

Module Stack_ml.
Definition t (A:Type) := loc.
End Stack_ml. 

(* todo: place functions in module *)

Parameter ml_stack_create : func.
Parameter ml_stack_is_empty : func.
Parameter ml_stack_push : func.
Parameter ml_stack_pop : func.


(********************************************************************)
(** IO manipulations *)

Parameter stdin : loc.
Parameter stdout : loc.

Parameter ml_read_int : func.
Parameter ml_print_int : func.

